Index: Makefile.am
===================================================================
--- Makefile.am	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ Makefile.am	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -1,4 +1,4 @@
 ACLOCAL_AMFLAGS = -I m4
-SUBDIRS = src src/Actions src/unittests doc tests 
+SUBDIRS = src src/unittests doc tests 
 
 EXTRA_DIST = autogen.sh
Index: configure.ac
===================================================================
--- configure.ac	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ configure.ac	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -27,10 +27,9 @@
 
 # Boost libraries
-AX_BOOST_BASE([1.33.1])
+AX_BOOST_BASE([1.40])
 AX_BOOST_PROGRAM_OPTIONS
 #AX_BOOST_FOREACH
 #AX_BOOST_FILESYSTEM
 AX_BOOST_THREAD
-#AX_BOOST_PROGRAM_OPTIONS
 #AX_BOOST_SERIALIZATION
 
@@ -93,12 +92,13 @@
 
 # test suite
-AC_CONFIG_TESTDIR(tests)
+AC_CONFIG_TESTDIR(tests/regression)
 AC_CONFIG_FILES([
-	tests/atlocal 
-	tests/Makefile])
+	tests/Makefile
+	tests/regression/atlocal 
+	tests/regression/Makefile])
+AC_CONFIG_FILES([tests/regression/molecuilder], [chmod +x tests/regression/molecuilder])
 AC_CONFIG_FILES([
 	tests/Tesselations/Makefile 
 	tests/Tesselations/defs])
-AC_CONFIG_FILES([tests/molecuilder], [chmod +x tests/molecuilder])
 AC_CONFIG_FILES([
 	doc/molecuilder.xml])
Index: src/Actions/FragmentationAction/DepthFirstSearchAction.cpp
===================================================================
--- src/Actions/FragmentationAction/DepthFirstSearchAction.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Actions/FragmentationAction/DepthFirstSearchAction.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -46,5 +46,5 @@
     molecule * const mol = World::getInstance().getMolecule(MoleculeById(0));
     MoleculeLeafClass *Subgraphs = NULL;      // list of subgraphs from DFS analysis
-    int *MinimumRingSize = new int[mol->AtomCount];
+    int *MinimumRingSize = new int[mol->getAtomCount()];
     atom ***ListOfLocalAtoms = NULL;
     class StackClass<bond *> *BackEdgeStack = NULL;
@@ -66,6 +66,6 @@
       delete(Subgraphs);
       for (int i=0;i<FragmentCounter;i++)
-        Free(&ListOfLocalAtoms[i]);
-      Free(&ListOfLocalAtoms);
+        delete[](ListOfLocalAtoms[i]);
+      delete[](ListOfLocalAtoms);
     }
     delete(BackEdgeStack);
Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Actions/Makefile.am	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -30,5 +30,6 @@
   ${TESSELATIONACTIONHEADER} \
   ${WORLDACTIONHEADER} \
-  MapOfActions.hpp
+  MapOfActions.hpp \
+  Values.hpp
   
 ANALYSISACTIONSOURCE = \
Index: src/Actions/MapOfActions.cpp
===================================================================
--- src/Actions/MapOfActions.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Actions/MapOfActions.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -12,7 +12,43 @@
 #include "Helpers/Assert.hpp"
 
+#include <boost/lexical_cast.hpp>
+#include <boost/optional.hpp>
+#include <boost/program_options.hpp>
+
 #include "CommandLineParser.hpp"
 #include "log.hpp"
 #include "verbose.hpp"
+
+#include "Actions/Values.hpp"
+
+void validate(boost::any& v, const std::vector<std::string>& values, VectorValue *, int)
+{
+  VectorValue VV;
+  if (values.size() != 3) {
+    cerr <<  "Specified vector does not have three components but " << values.size() << endl;
+    throw boost::program_options::validation_error("Specified vector does not have three components");
+  }
+  VV.x = boost::lexical_cast<double>(values.at(0));
+  VV.y = boost::lexical_cast<double>(values.at(1));
+  VV.z = boost::lexical_cast<double>(values.at(2));
+  v = boost::any(VectorValue(VV));
+}
+
+void validate(boost::any& v, const std::vector<std::string>& values, BoxValue *, int)
+{
+  BoxValue BV;
+  if (values.size() != 6) {
+    cerr <<  "Specified vector does not have three components but " << values.size() << endl;
+    throw boost::program_options::validation_error("Specified symmetric box matrix does not have six components");
+  }
+  BV.xx = boost::lexical_cast<double>(values.at(0));
+  BV.xy = boost::lexical_cast<double>(values.at(1));
+  BV.xz = boost::lexical_cast<double>(values.at(2));
+  BV.yy = boost::lexical_cast<double>(values.at(3));
+  BV.yz = boost::lexical_cast<double>(values.at(4));
+  BV.zz = boost::lexical_cast<double>(values.at(5));
+  v = boost::any(BoxValue(BV));
+}
+
 
 /** Constructor of class MapOfActions.
@@ -62,4 +98,5 @@
   DescriptionMap["save-bonds"] = "name of the bonds file to write to";
   DescriptionMap["save-temperature"] = "name of the temperature file to write to";
+  DescriptionMap["scale-box"] = "scale box and atomic positions inside";
   DescriptionMap["subspace-dissect"] = "dissect the molecular system into molecules representing disconnected subgraphs";
   DescriptionMap["suspend-in-water"] = "suspend the given molecule in water such that in the domain the mean density is as specified";
@@ -75,4 +112,5 @@
   DescriptionMap["distance"] = "distance in space";
   DescriptionMap["distances"] = "list of three of distances in space, one for each axis direction";
+  DescriptionMap["DoRotate"] = "whether to rotate or just report angles";
   DescriptionMap["element"] = "set of elements";
   DescriptionMap["end-mol"] = "last or end step";
@@ -92,5 +130,5 @@
   ShortFormMap["bond-file"] = "A";
   ShortFormMap["boundary"] = "c";
-  ShortFormMap["bound-in-box"] = "B";
+  ShortFormMap["change-box"] = "B";
   ShortFormMap["center-edge"] = "O";
   ShortFormMap["center-in-box"] = "b";
@@ -123,7 +161,7 @@
   ShortFormMap["suspend-in-water"] = "U";
   ShortFormMap["translate-mol"] = "t";
-  ShortFormMap["verbose"] = "V";
+  ShortFormMap["verbose"] = "v";
   ShortFormMap["verlet-integrate"] = "P";
-  ShortFormMap["version"] = "v";
+  ShortFormMap["version"] = "V";
 
   // value types for the actions
@@ -132,5 +170,6 @@
   TypeMap["bond-table"] = String;
   TypeMap["boundary"] = Vector;
-  TypeMap["change-box"] = Vector;
+  TypeMap["center-in-box"] = Box;
+  TypeMap["change-box"] = Box;
   TypeMap["change-element"] = Element;
   TypeMap["change-molname"] = String;
@@ -151,5 +190,5 @@
   TypeMap["remove-atom"] = Atom;
   TypeMap["remove-sphere"] = Atom;
-  TypeMap["repeat-box"] = ListOfInts;
+  TypeMap["repeat-box"] = Vector;
   TypeMap["rotate-to-pas"] = Molecule;
   TypeMap["save-adjacency"] = String;
@@ -163,4 +202,5 @@
   TypeMap["verlet-integrate"] = String;
   TypeMap["verbose"] = Integer;
+
   // value types for the values
   TypeMap["bin-output-file"] = String;
@@ -168,9 +208,10 @@
   TypeMap["bin-start"] = Double;
   TypeMap["distance"] = Double;
-  TypeMap["distances"] = ListOfDoubles;
+  TypeMap["distances"] = Vector;
+  TypeMap["DoRotate"] = Boolean;
   TypeMap["elements"] = Element;
   TypeMap["elements"] = ListOfElements;
   TypeMap["length"] = Double;
-  TypeMap["lengths"] = ListOfDoubles;
+  TypeMap["lengths"] = Vector;
   TypeMap["MaxDistance"] = Double;
   TypeMap["molecule-by-id"] = Molecule;
@@ -179,13 +220,17 @@
   TypeMap["position"] = Vector;
 
+  // default values for any action that needs one (always string!)
+  DefaultValue["molecule-by-id"] = "-1";
+
+
   // list of generic actions
 //	generic.insert("add-atom");
 //  generic.insert("bond-file");
 //	generic.insert("bond-table");
-//  generic.insert("boundary");
+  generic.insert("boundary");
 //  generic.insert("bound-in-box");
-//  generic.insert("center-edge");
-//  generic.insert("center-in-box");
-//	generic.insert("change-box");
+  generic.insert("center-edge");
+  generic.insert("center-in-box");
+	generic.insert("change-box");
 //  generic.insert("change-molname");
 //	generic.insert("change-element");
@@ -195,5 +240,5 @@
 //	generic.insert("element-db");
 //	generic.insert("fastparsing");
-//  generic.insert("fill-molecule");
+  generic.insert("fill-molecule");
 //  generic.insert("fragment-mol");
   generic.insert("help");
@@ -208,9 +253,10 @@
 //  generic.insert("remove-atom");
 //  generic.insert("remove-sphere");
+  generic.insert("repeat-box");
 //  generic.insert("rotate-to-pas");
 //	generic.insert("save-adjacency");
 //  generic.insert("save-bonds");
 //  generic.insert("save-temperature");
-//  generic.insert("scale-box");
+  generic.insert("scale-box");
 //  generic.insert("set-basis");
 //	generic.insert("subspace-dissect");
@@ -230,7 +276,4 @@
     generic.insert("input");
 //  generic.insert("length");
-//  generic.insert("lengths");
-//  generic.insert("MaxDistance");
-//  generic.insert("molecule-by-id");
 //  generic.insert("output-file");
 //  generic.insert("periodic");
@@ -240,4 +283,12 @@
     // positional arguments
     inputfile.insert("input");
+
+    // hidden arguments
+//  generic.insert("distance");
+    generic.insert("DoRotate");
+    generic.insert("distances");
+    generic.insert("lengths");
+    generic.insert("MaxDistance");
+    generic.insert("molecule-by-id");
 }
 
@@ -269,75 +320,121 @@
           case Boolean:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< bool >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
+                        po::value< bool >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
+                        po::value< bool >(),
+                  getDescription(*OptionRunner).c_str())
+              ;
+            break;
+          case Box:
+            ListRunner->second->add_options()
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value<BoxValue>()->multitoken(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case Integer:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< int >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
+                        po::value< int >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
+                        po::value< int >(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case ListOfInts:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< vector<int> >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value< vector<int> >()->multitoken(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case Double:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< double >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
+                        po::value< double >()->default_value(atof(DefaultValue[*OptionRunner].c_str())) :
+                        po::value< double >(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case ListOfDoubles:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< vector<double> >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value< vector<double> >()->multitoken(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case String:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< std::string >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
+                        po::value< std::string >()->default_value(DefaultValue[*OptionRunner]) :
+                        po::value< std::string >(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case Axis:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< int >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
+                        po::value< int >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
+                        po::value< int >(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case Vector:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< vector<double> >(), getDescription(*OptionRunner).c_str())
-              ;
-            break;
-          case Box:
-            ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< vector<double> >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value<VectorValue>()->multitoken(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case Molecule:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< int >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
+                        po::value< int >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
+                        po::value< int >(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case ListOfMolecules:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< vector<int> >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value< vector<int> >()->multitoken(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case Atom:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< int >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
+                        po::value< int >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
+                        po::value< int >(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case ListOfAtoms:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< vector<int> >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value< vector<int> >()->multitoken(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case Element:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< int >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
+                        po::value< int >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
+                        po::value< int >(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
           case ListOfElements:
             ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(), po::value< vector<int> >(), getDescription(*OptionRunner).c_str())
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value< vector<int> >()->multitoken(),
+                  getDescription(*OptionRunner).c_str())
               ;
             break;
Index: src/Actions/MapOfActions.hpp
===================================================================
--- src/Actions/MapOfActions.hpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Actions/MapOfActions.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -53,4 +53,5 @@
 
   // map of the action names and their description
+  map<std::string, std::string> DefaultValue;
   map<std::string, std::string> DescriptionMap;
   map<std::string, std::string> ShortFormMap;
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -66,28 +66,29 @@
 
   if(dialog->display()) {
+    DoLog(1) && (Log() << Verbose(1) << "Filling Box with water molecules, lengths(" << lengths[0] << "," << lengths[1] << "," << lengths[2] << "), distances (" << distances[0] << "," << distances[1] << "," << distances[2] << "), MaxDistance " << MaxDistance << ", DoRotate " << DoRotate << "." << endl);
     // construct water molecule
     molecule *filler = World::getInstance().createMolecule();
-//    if (!filler->AddXYZFile(filename)) {
-//      DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse filler molecule from " << filename << "." << endl);
-//    }
-//    filler->SetNameFromFilename(filename);
+    if (!filler->AddXYZFile(filename)) {
+      DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse filler molecule from " << filename << "." << endl);
+    }
+    filler->SetNameFromFilename(filename.c_str());
     molecule *Filling = NULL;
-    atom *first = NULL, *second = NULL, *third = NULL;
-    first = World::getInstance().createAtom();
-    first->type = World::getInstance().getPeriode()->FindElement(1);
-    first->x = Vector(0.441, -0.143, 0.);
-    filler->AddAtom(first);
-    second = World::getInstance().createAtom();
-    second->type = World::getInstance().getPeriode()->FindElement(1);
-    second->x = Vector(-0.464, 1.137, 0.0);
-    filler->AddAtom(second);
-    third = World::getInstance().createAtom();
-    third->type = World::getInstance().getPeriode()->FindElement(8);
-    third->x = Vector(-0.464, 0.177, 0.);
-    filler->AddAtom(third);
-    filler->AddBond(first, third, 1);
-    filler->AddBond(second, third, 1);
+//    atom *first = NULL, *second = NULL, *third = NULL;
+//    first = World::getInstance().createAtom();
+//    first->type = World::getInstance().getPeriode()->FindElement(1);
+//    first->x = Vector(0.441, -0.143, 0.);
+//    filler->AddAtom(first);
+//    second = World::getInstance().createAtom();
+//    second->type = World::getInstance().getPeriode()->FindElement(1);
+//    second->x = Vector(-0.464, 1.137, 0.0);
+//    filler->AddAtom(second);
+//    third = World::getInstance().createAtom();
+//    third->type = World::getInstance().getPeriode()->FindElement(8);
+//    third->x = Vector(-0.464, 0.177, 0.);
+//    filler->AddAtom(third);
+//    filler->AddBond(first, third, 1);
+//    filler->AddBond(second, third, 1);
     World::getInstance().getConfig()->BG->ConstructBondGraph(filler);
-    filler->SetNameFromFilename("water");
+//    filler->SetNameFromFilename("water");
     // call routine
     double distance[NDIM];
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -65,5 +65,5 @@
     DoLog(0) && (Log() << Verbose(0) << "Evaluating non-convex envelope of molecule." << Boundary->getId() << endl);
     DoLog(1) && (Log() << Verbose(1) << "Using rolling ball of radius " << SphereRadius << " and storing tecplot data in " << filename << "." << endl);
-    DoLog(1) && (Log() << Verbose(1) << "Specified molecule has " << Boundary->AtomCount << " atoms." << endl);
+    DoLog(1) && (Log() << Verbose(1) << "Specified molecule has " << Boundary->getAtomCount() << " atoms." << endl);
     start = clock();
     LCList = new LinkedCell(Boundary, SphereRadius*2.);
Index: src/Actions/Values.hpp
===================================================================
--- src/Actions/Values.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
+++ src/Actions/Values.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -0,0 +1,29 @@
+/*
+ * Values.hpp
+ *
+ *  Created on: Jun 7, 2010
+ *      Author: heber
+ */
+
+#ifndef VALUES_HPP_
+#define VALUES_HPP_
+
+struct VectorValue
+{
+  double x;
+  double y;
+  double z;
+};
+
+struct BoxValue
+{
+  double xx;
+  double xy;
+  double xz;
+  double yy;
+  double yz;
+  double zz;
+};
+
+
+#endif /* VALUES_HPP_ */
Index: src/Actions/WorldAction/AddEmptyBoundaryAction.cpp
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -69,5 +69,5 @@
     AtomRunner = AllAtoms.begin();
     for (; AtomRunner != AllAtoms.end(); ++AtomRunner)
-      (*AtomRunner)->x -= Min;
+      (*AtomRunner)->x -= Min - boundary;
     delete dialog;
     return Action::success;
Index: src/Actions/WorldAction/CenterInBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Actions/WorldAction/CenterInBoxAction.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -33,5 +33,6 @@
   Dialog *dialog = UIFactory::getInstance().makeDialog();
 
-  dialog->queryEmpty(NAME, MapOfActions::getInstance().getDescription(NAME));
+  double * cell_size = World::getInstance().getDomain();
+  dialog->queryBox(NAME, &cell_size, MapOfActions::getInstance().getDescription(NAME));
 
   if(dialog->display()) {
Index: src/Actions/WorldAction/RepeatBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/RepeatBoxAction.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Actions/WorldAction/RepeatBoxAction.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -23,4 +23,6 @@
 #include "UIElements/Dialog.hpp"
 #include "Actions/MapOfActions.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "Descriptors/MoleculePtrDescriptor.hpp"
 
 const char WorldRepeatBoxAction::NAME[] = "repeat-box";
@@ -40,13 +42,25 @@
   molecule *mol = NULL;
   int j = 0;
+  atom *Walker = NULL;
+  MoleculeListClass *molecules = World::getInstance().getMolecules();
 
   dialog->queryVector(NAME, &Repeater, World::getInstance().getDomain(), false, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryMolecule("molecule-by-id", &mol,MapOfActions::getInstance().getDescription("molecule-by-id"));
+  //dialog->queryMolecule("molecule-by-id", &mol,MapOfActions::getInstance().getDescription("molecule-by-id"));
+  vector<molecule *> AllMolecules;
+  if (mol != NULL) {
+    DoLog(0) && (Log() << Verbose(0) << "Using molecule " << mol->name << "." << endl);
+    AllMolecules = World::getInstance().getAllMolecules(MoleculeByPtr(mol));
+  } else {
+    DoLog(0) && (Log() << Verbose(0) << "Using all molecules." << endl);
+    AllMolecules = World::getInstance().getAllMolecules();
+  }
 
   if(dialog->display()) {
+    (cout << "Repeating box " << Repeater << " times for (x,y,z) axis." << endl);
     double * const cell_size = World::getInstance().getDomain();
+    double *M = ReturnFullMatrixforSymmetric(cell_size);
     Vector x,y;
-    for (int axis = 1; axis <= NDIM; axis++) {
-      Vector ** vectors;
+    int n[NDIM];
+    for (int axis = 0; axis < NDIM; axis++) {
       Repeater[axis] = floor(Repeater[axis]);
       if (Repeater[axis] < 1) {
@@ -54,42 +68,54 @@
         Repeater[axis] = 1;
       }
-      mol->CountAtoms();  // recount atoms
-      if (mol->AtomCount != 0) {  // if there is more than none
-        count = mol->AtomCount;   // is changed becausing of adding, thus has to be stored away beforehand
-        Elements = new const element *[count];
-        vectors = new Vector *[count];
-        j = 0;
-        atom *first = mol->start;
-        while (first->next != mol->end) {  // make a list of all atoms with coordinates and element
-          first = first->next;
-          Elements[j] = first->type;
-          vectors[j] = &first->x;
-          j++;
-        }
-        if (count != j)
-          DoeLog(1) && (eLog()<< Verbose(1) << "AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl);
-        x.Zero();
-        y.Zero();
-        y[abs(axis)-1] = cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] * abs(axis)/axis; // last term is for sign, first is for magnitude
-        for (int i=1;i<Repeater[axis];i++) {  // then add this list with respective translation factor times
-          x += y; // per factor one cell width further
-          for (int k=count;k--;) { // go through every atom of the original cell
-            first = World::getInstance().createAtom(); // create a new body
-            first->x = (*vectors[k]) + x;
-            first->type = Elements[k];  // insert original element
-            mol->AddAtom(first);        // and add to the molecule (which increments ElementsInMolecule, AtomCount, ...)
+      cell_size[(abs(axis+1) == 2) ? 2 : ((abs(axis+2) == 3) ? 5 : 0)] *= Repeater[axis];
+    }
+
+    molecule *newmol = NULL;
+    Vector ** vectors = NULL;
+    for (n[0] = 0; n[0] < Repeater[0]; n[0]++) {
+      y[0] = n[0];
+      for (n[1] = 0; n[1] < Repeater[1]; n[1]++) {
+        y[1] = n[1];
+        for (n[2] = 0; n[2] < Repeater[2]; n[2]++) {
+          y[2] = n[2];
+          if (n[0] == n[1] == n[2] == 0)
+            continue;
+          for (vector<molecule *>::iterator MolRunner = AllMolecules.begin(); MolRunner != AllMolecules.end(); ++MolRunner) {
+            mol = *MolRunner;
+            DoLog(1) && (Log() << Verbose(1) << "Current mol is " << mol->name << "." << endl);
+            count = mol->getAtomCount();   // is changed becausing of adding, thus has to be stored away beforehand
+            if (count != 0) {  // if there is more than none
+              Elements = new const element *[count];
+              vectors = new Vector *[count];
+              j = 0;
+              for(molecule::iterator AtomRunner = mol->begin(); AtomRunner != mol->end(); ++AtomRunner) {
+                Elements[j] = (*AtomRunner)->type;
+                vectors[j] = &(*AtomRunner)->x;
+                j++;
+              }
+              if (count != j)
+                DoeLog(1) && (eLog()<< Verbose(1) << "AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl);
+              x = y;
+              x.MatrixMultiplication(M);
+              newmol = World::getInstance().createMolecule();
+              molecules->insert(newmol);
+              for (int k=count;k--;) { // go through every atom of the original cell
+                Walker = World::getInstance().createAtom(); // create a new body
+                Walker->x = (*vectors[k]) + x;
+                Walker->type = Elements[k];  // insert original element
+                cout << "new atom is " << *Walker << endl;
+                newmol->AddAtom(Walker);        // and add to the molecule (which increments ElementsInMolecule, AtomCount, ...)
+              }
+              // free memory
+              delete[](Elements);
+              delete[](vectors);
+            } else {
+              DoLog(1) && (Log() << Verbose(1) << "\t ... is empty." << endl);
+            }
           }
         }
-        // free memory
-        delete[](Elements);
-        delete[](vectors);
-        // correct cell size
-        if (axis < 0) { // if sign was negative, we have to translate everything
-          x =(-(Repeater[axis]-1)) * y;
-          mol->Translate(&x);
-        }
-        cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] *= Repeater[axis];
       }
     }
+    delete(M);
     delete dialog;
     return Action::success;
Index: src/Descriptors/MoleculePtrDescriptor.cpp
===================================================================
--- src/Descriptors/MoleculePtrDescriptor.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
+++ src/Descriptors/MoleculePtrDescriptor.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -0,0 +1,40 @@
+/*
+ * MoleculePtrDescriptor.cpp
+ *
+ *  Created on: Feb 5, 2010
+ *      Author: crueger
+ */
+
+#include "MoleculePtrDescriptor.hpp"
+#include "MoleculePtrDescriptor_impl.hpp"
+
+#include "molecule.hpp"
+
+using namespace std;
+
+
+MoleculePtrDescriptor_impl::MoleculePtrDescriptor_impl(molecule * _ptr) :
+  ptr(_ptr)
+{}
+
+MoleculePtrDescriptor_impl::~MoleculePtrDescriptor_impl()
+{}
+
+bool MoleculePtrDescriptor_impl::predicate(std::pair<moleculeId_t,molecule*> molecule) {
+  return molecule.second==ptr;
+}
+
+MoleculeDescriptor MoleculeByPtr(molecule * ptr){
+  return MoleculeDescriptor(MoleculeDescriptor::impl_ptr(new MoleculePtrDescriptor_impl(ptr)));
+}
+
+molecule *MoleculePtrDescriptor_impl::find(){
+  World::MoleculeSet molecules = getMolecules();
+  World::MoleculeSet::iterator res = molecules.find(ptr->getId());
+  return (res!=molecules.end())?((*res).second):0;
+}
+
+vector<molecule*> MoleculePtrDescriptor_impl::findAll(){
+  molecule *res = find();
+  return (res)?(vector<molecule*>(1,res)):(vector<molecule*>());
+}
Index: src/Descriptors/MoleculePtrDescriptor.hpp
===================================================================
--- src/Descriptors/MoleculePtrDescriptor.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
+++ src/Descriptors/MoleculePtrDescriptor.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -0,0 +1,16 @@
+/*
+ * MoleculeIdDescriptor.hpp
+ *
+ *  Created on: Feb 5, 2010
+ *      Author: crueger
+ */
+
+#ifndef MOLECULEPTRDESCRIPTOR_HPP_
+#define MOLECULEPTRDESCRIPTOR_HPP_
+
+#include "defs.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
+
+MoleculeDescriptor MoleculeByPtr(molecule * ptr);
+
+#endif /* MOLECULEPTRDESCRIPTOR_HPP_ */
